<template>
<!-- Modified navigation bar to include appropriate links. -->
  <div id="app">
    <Nav :loggedIn="loggedIn" :profileRoute="profileRoute"/>
    <!-- Router-view essentially displays the appropriate web page based on the router URL
    defined in index.js. Global variables are passed here to all children components. -->
    <router-view
    :user="user"
    :inventory="inventory"
    :selectedItem="selectedItem"
    :selectedInventory="selectedInventory"
    @select-inventory="recordInventory"
    @selected-item="recordItem"
    />
  </div>
</template>

<script>
// Importing axios to make requests to the backend.
import Nav from './components/Nav'
import axios from 'axios'
export default {
  name: 'App',
  components: {
    Nav
  },
  data () {
    return {
      user: null,
      inventory: null,
      loggedIn: false,
      selectedItem: null,
      selectedInventory: null,
      profileRoute: '/profile/',
      baseUrl: 'http://localhost:8000/api/'
    }
  },
  // Async method that waits for a user to login to store its data globally
  async created () {
    const response = await axios.get(this.baseUrl + 'user', {
      headers: {
        Authorization: 'Bearer ' + localStorage.getItem('token')
      }
    })
    this.user = response.data
    this.loggedIn = true
    this.profileRoute = '/profile/' + this.user.user_id
  },
  methods: {
    async recordInventory (e) {
      this.inventory = e
    },
    async recordItem (e, y) {
      console.log(y)
      this.selectedItem = e
      this.selectedInventory = y
    }
  }
}
</script>

<style>
  @import url('https://fonts.googleapis.com/css?family=Fira+Sans:400,500,600,700,800');
/* General css */
  * {
    box-sizing: border-box;
  }

  body {
    min-height: 100vh;
    display: flex;
    font-weight: 400;
    font-family: 'Fira Sans', sans-serif;
  }

  h1, h2, h3, h4, h5, h6, label, span {
    font-weight: 500;
    font-family: 'Fira Sans', sans-serif;
  }

  body, html, #app, #root, #auth-wrapper {
    width: 100%;
    background-size: cover;
  }

  #app {
    padding: 5% 0 0 0;
    text-align: center;
    background-image: url('./assets/bck.jpg');
    background-size: cover;
  }

  #nav a {
    font-weight: bold;
    color: #2c3e50;
  }

  #nav a.router-link-exact-active {
    color: #42b983;
  }

  .navbar-dark {
    background-color: #292b2c;
    box-shadow: 0px 14px 80px rgba(34, 35, 58, 0.2);
  }

  .auth-wrapper {
    display: flex;
    justify-content: center;
    flex-direction: column;
    text-align: left;
  }

  .auth-inner {
    width: 450px;
    margin: auto;
    background: #ffffff;
    box-shadow: 0px 14px 80px rgba(34, 35, 58, 0.2);
    padding: 40px 55px 45px 55px;
    border-radius: 15px;
    transition: all .3s;
  }

  .auth-wrapper .form-control:focus {
    border-color: lightgrey;
    box-shadow: none;
  }

  .auth-wrapper h3 {
    text-align: center;
    margin: 0;
    line-height: 1;
    padding-bottom: 20px;
  }

  .custom-control-label {
    font-weight: 400;
  }

  .forgot-password,
  .forgot-password a {
    text-align: right;
    font-size: 13px;
    padding-top: 10px;
    color: #7f7d7d;
    margin: 0;
  }

  .forgot-password a {
    color: lightgrey;
  }
</style>
